#include "CivTableTemp.h"
#include "CivDbConn.h"

CivTableTemp::CivTableTemp()
{
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_INT, "int"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_INTEGER,"integer"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DOUBLE, "double precision"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR, "varchar(32)"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR64, "varchar(64)"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR128, "varchar(128)"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_VARCHAR256,"varchar(256)"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_BOOLEAN, "boolean"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_CHARACTER_VARYING,"character varying"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DATETIME, "timestamp"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_JSON, "json"));
	mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_DATE, "date"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_GEOM_POINT,"geometry(Point,4326)"));
    mFieldTyepMap.insert(std::pair<FieldType, std::string>(CivTableTemp::FILED_GEOM_LINE, "geometry(MultiLineString,4326)"));
}

CivTableTemp::~CivTableTemp()
{

}

void CivTableTemp::addProperty(Str fileName, FieldType filedType)
{
	FieldProperty prop = { fileName ,mFieldTyepMap.find(filedType)->second};
	mPropertys.push_back(prop);
}

Str CivTableTemp::createSql()
{
	if (mPropertys.size() <= 0)
		return Str();

    char sql[512] = "create table ";

	strcat_s(sql, mTableName.c_str());
	strcat_s(sql, "(id serial primary key");
	size_t total = mPropertys.size();
	for (int i = 0; i < total; i++)
	{
		FieldProperty property = mPropertys[i];
		strcat_s(sql, ",");
		strcat_s(sql, property.mFiledName.c_str());
		strcat_s(sql, "  ");
		strcat_s(sql, property.mFieldType.c_str());
	}
	strcat_s(sql, ")");

	return sql;
}

bool CivTableTemp::updateToDb(CivDbConn* dbConn)
{
    if (dbConn == nullptr)
        return false;

    Str sql = createSql();
    return true;
}

CivJunctionTableTemp::CivJunctionTableTemp(Str tableName)
{
    setName(PIPENODE);

    TableFileds fileds;
     addProperty(fileds.ID ,CivTableTemp::FILED_VARCHAR);// "id";
     addProperty(fileds.geom ,CivTableTemp::FILED_VARCHAR);// "geom";
     addProperty(fileds.thePoint ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.xCoord ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.yCoord ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.elev ,CivTableTemp::FILED_VARCHAR);// "߳";
     addProperty(fileds.demand ,CivTableTemp::FILED_VARCHAR);// "ˮ";
     addProperty(fileds.pattern ,CivTableTemp::FILED_VARCHAR);// "ˮģʽ";
     addProperty(fileds.head ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.freeHead ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.actualDemand ,CivTableTemp::FILED_VARCHAR);// "ʵˮ";
     addProperty(fileds.code ,CivTableTemp::FILED_VARCHAR);// "code";
     addProperty(fileds.createUser ,CivTableTemp::FILED_VARCHAR);// "create_user";
     addProperty(fileds.modifyUser ,CivTableTemp::FILED_VARCHAR);// "modify_user";
     addProperty(fileds.createTime ,CivTableTemp::FILED_VARCHAR);// "create_time";
     addProperty(fileds. modifyTime ,CivTableTemp::FILED_VARCHAR);// "modify_time";
     addProperty(fileds.symbolAngle ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
     addProperty(fileds.compType ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.pressure ,CivTableTemp::FILED_VARCHAR);// "ѹ";
     addProperty(fileds.quality ,CivTableTemp::FILED_VARCHAR);// "ˮ";
};

/**
߱ģ
*/
CivPipeTableTemp::CivPipeTableTemp() :CivTableTemp()
{
    setName(PIPELINE);

    TableFileds fileds;
     addProperty(fileds.ID ,CivTableTemp::FILED_VARCHAR);// "id";
     addProperty(fileds.geom ,CivTableTemp::FILED_VARCHAR);// "geom";
     addProperty(fileds.snNo ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.thePoint ,CivTableTemp::FILED_VARCHAR);// "ϵ";
     addProperty(fileds.lastPoint ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.length ,CivTableTemp::FILED_VARCHAR);// "ܳ";
     addProperty(fileds.material ,CivTableTemp::FILED_VARCHAR);// "ܲ";
     addProperty(fileds.diameter ,CivTableTemp::FILED_VARCHAR);// "ܾ";
     addProperty(fileds.friction ,CivTableTemp::FILED_VARCHAR);// "Ħϵ";
     addProperty(fileds.localLoss ,CivTableTemp::FILED_VARCHAR);// "ֲʧϵ";
     addProperty(fileds.initStatus ,CivTableTemp::FILED_VARCHAR);// "ʼ״̬";
     addProperty(fileds.buryingTime ,CivTableTemp::FILED_VARCHAR);// "ʱ";
     addProperty(fileds.flow ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.velocity ,CivTableTemp::FILED_VARCHAR);// "";
     addProperty(fileds.unitHeadLoss ,CivTableTemp::FILED_VARCHAR);// "λˮͷ";
     addProperty(fileds.headLoss ,CivTableTemp::FILED_VARCHAR);// "ˮͷʧ";
     addProperty(fileds.unitPressLoss ,CivTableTemp::FILED_VARCHAR);// "λѹ";
     addProperty(fileds.pressLoss ,CivTableTemp::FILED_VARCHAR);// "ѹʧ";
     addProperty(fileds.lastHead ,CivTableTemp::FILED_VARCHAR);// "ϵˮͷ";
     addProperty(fileds.theHead ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
     addProperty(fileds.lastPress ,CivTableTemp::FILED_VARCHAR);// "ϵѹ";
     addProperty(fileds.thePress ,CivTableTemp::FILED_VARCHAR);// "ѹ";
     addProperty(fileds.localHeadLoss ,CivTableTemp::FILED_VARCHAR);// "ֲˮͷ";
     addProperty(fileds.fracHeadLoss ,CivTableTemp::FILED_VARCHAR);// "Ħˮͷ";
     addProperty(fileds.status ,CivTableTemp::FILED_VARCHAR);// "״̬";
     addProperty(fileds.guid ,CivTableTemp::FILED_VARCHAR);// "guid";
     addProperty(fileds.code ,CivTableTemp::FILED_VARCHAR);// "code";
     addProperty(fileds.fromCode ,CivTableTemp::FILED_VARCHAR);// "from_code";
     addProperty(fileds.fromLayer ,CivTableTemp::FILED_VARCHAR);// "from_layer";
     addProperty(fileds.toCode ,CivTableTemp::FILED_VARCHAR);// "to_code";
     addProperty(fileds.toLayer ,CivTableTemp::FILED_VARCHAR);// "to_layer";
     addProperty(fileds.createUser ,CivTableTemp::FILED_VARCHAR);// "create_user";
     addProperty(fileds.modifyUser ,CivTableTemp::FILED_VARCHAR);// "modify_user";
     addProperty(fileds.createTime ,CivTableTemp::FILED_VARCHAR);// "create_time";
     addProperty(fileds.modifyTime ,CivTableTemp::FILED_VARCHAR);// "modify_time";
     addProperty(fileds.remarks ,CivTableTemp::FILED_VARCHAR);// "ע";
     addProperty(fileds.quality ,CivTableTemp::FILED_VARCHAR);// "ˮ";
}

/**
ˮ
*/
CivPumpTableTemp::CivPumpTableTemp() :CivTableTemp()
{
    setName(PUMP);

    TableFileds fileds;
    addProperty(fileds.ID, CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom, CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.startPoint, CivTableTemp::FILED_VARCHAR);// "ʼڵ";
    addProperty(fileds.endPoint, CivTableTemp::FILED_VARCHAR);// "ֹڵ";
    addProperty(fileds.curve, CivTableTemp::FILED_VARCHAR);// "ˮ";
    addProperty(fileds.ratio, CivTableTemp::FILED_VARCHAR);// "תٱ";
    addProperty(fileds.flow, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headCurve, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.status, CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.code, CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser, CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser, CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime, CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime, CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle, CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType, CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.power, CivTableTemp::FILED_VARCHAR);// "";
}

/**
   ˮ
*/
CivTankTableTemp::CivTankTableTemp() :CivTableTemp()
{
    setName(TANK);

    TableFileds fileds;
    addProperty(fileds.ID  ,CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.elev  ,CivTableTemp::FILED_VARCHAR);// "߳";
    addProperty(fileds.diametor  ,CivTableTemp::FILED_VARCHAR);// "ֱ";
    addProperty(fileds.baseLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.initLevel  ,CivTableTemp::FILED_VARCHAR);// "ʼˮλ";
    addProperty(fileds.highLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.lowLevel  ,CivTableTemp::FILED_VARCHAR);// "ˮλ";
    addProperty(fileds.flowIn  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.flowOut  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.leveHeight  ,CivTableTemp::FILED_VARCHAR);// "Һλ߶";
    addProperty(fileds.capacity  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.percentage  ,CivTableTemp::FILED_VARCHAR);// "װˮذ";
    addProperty(fileds.status  ,CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**
  ˮ
*/
CivResourcesTableTemp::CivResourcesTableTemp() :CivTableTemp()
{
    setName(RESIVOIR);

    TableFileds fileds;

    addProperty(fileds.ID  ,CivTableTemp::FILED_VARCHAR);// "id";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.thePoint  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headPattern  ,CivTableTemp::FILED_VARCHAR);// "ˮͷģʽ";
    addProperty(fileds.elev  ,CivTableTemp::FILED_VARCHAR);// "߳";
    addProperty(fileds.head  ,CivTableTemp::FILED_VARCHAR);// "ˮͷ";
    addProperty(fileds.flow  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modifyUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.SymbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**

*/
CivValveTableTemp::CivValveTableTemp() :CivTableTemp()
{
    setName(VALVE);

    TableFileds fileds;
    addProperty(fileds.id  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.geom  ,CivTableTemp::FILED_VARCHAR);// "geom";
    addProperty(fileds.xCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.yCoord  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.startPoint  ,CivTableTemp::FILED_VARCHAR);// "ʼڵ";
    addProperty(fileds.endPoint  ,CivTableTemp::FILED_VARCHAR);// "ֹڵ";
    addProperty(fileds.diameter  ,CivTableTemp::FILED_VARCHAR);// "ֱ";
    addProperty(fileds.status  ,CivTableTemp::FILED_VARCHAR);// "״̬";
    addProperty(fileds.type  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.setting  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.loss  ,CivTableTemp::FILED_VARCHAR);// "ʧϵ";
    addProperty(fileds.flow  ,CivTableTemp::FILED_VARCHAR);// " ";
    addProperty(fileds.veclocity  ,CivTableTemp::FILED_VARCHAR);// "";
    addProperty(fileds.headLoss  ,CivTableTemp::FILED_VARCHAR);// "ˮͷʧ";
    addProperty(fileds.code  ,CivTableTemp::FILED_VARCHAR);// "code";
    addProperty(fileds.createUser  ,CivTableTemp::FILED_VARCHAR);// "create_user";
    addProperty(fileds.modityUser  ,CivTableTemp::FILED_VARCHAR);// "modify_user";
    addProperty(fileds.createTime  ,CivTableTemp::FILED_VARCHAR);// "create_time";
    addProperty(fileds.modifyTime  ,CivTableTemp::FILED_VARCHAR);// "modify_time";
    addProperty(fileds.symbolAngle  ,CivTableTemp::FILED_VARCHAR);// "symbol_angle";
    addProperty(fileds.compType  ,CivTableTemp::FILED_VARCHAR);// "";
}

/**
   ڵģ洢
*/
CivNodeResultTableTemp::CivNodeResultTableTemp() :CivTableTemp()
{

    setName(NODERESULTTABLE);

    NodeResultTable nodeTable;
    addProperty(nodeTable.Number, CivTableTemp::FILED_VARCHAR);
    addProperty(nodeTable.dPressure, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dHead, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dElevation, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dDemand, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankVolume, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankMaxVolume, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dTankLevel, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(nodeTable.dDate, CivTableTemp::FILED_DATE);
    addProperty(nodeTable.dInterval, CivTableTemp::FILED_INT);
    addProperty(nodeTable.dModifyTime, CivTableTemp::FILED_DATETIME);
}

/**
	ģ߱
*/
CivPipeResultTableTemp::CivPipeResultTableTemp() :CivTableTemp()
{

    setName(PIPERESULTTABLE);

    TableField pipeFileds;
    addProperty(pipeFileds.szNo, CivTableTemp::FILED_VARCHAR);
    addProperty(pipeFileds.dFlow, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.nFlowDirect, CivTableTemp::FILED_INT);
    addProperty(pipeFileds.dVelocity, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dUnitHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dFromNodHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dToNodHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dLocalHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dFrictionHeadloss, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.szStatus, CivTableTemp::FILED_VARCHAR);
    addProperty(pipeFileds.dQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(pipeFileds.dDate, CivTableTemp::FILED_DATE);
    addProperty(pipeFileds.dInterval, CivTableTemp::FILED_INT);
    addProperty(pipeFileds.dModifyTime, CivTableTemp::FILED_DATETIME);
}

/**
	 ģʽ
*/
CivPatternTableTemp::CivPatternTableTemp() :CivTableTemp()
{
    setName(PATTERNTABLE);

    TableField fileds;
    addProperty(fileds.modelName, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.modelData, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.modelType, CivTableTemp::FILED_INTEGER);
}

/**
	
*/
CivParametorTableTemp::CivParametorTableTemp() :CivTableTemp() 
{
    setName(OPTIONTTABLE);
    TableField fileds;
    addProperty(fileds.name, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.val, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.type, CivTableTemp::FILED_VARCHAR);
    addProperty(fileds.netName, CivTableTemp::FILED_VARCHAR64);
}

/**
   ߱
*/
CivCurveTableTemp::CivCurveTableTemp() :CivTableTemp()
{
    setName(CURVETABLE);
    TableField fileds;
    addProperty(fileds.CurveName, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.CurveType, CivTableTemp::FILED_INTEGER);
    addProperty(fileds.CurveData, CivTableTemp::FILED_VARCHAR256);
}


/**
   
*/
CivProjNodeTableTemp::CivProjNodeTableTemp() :CivTableTemp()
{
    setName(PROJNODETABLE);
    TableField fileds;

    addProperty(fileds.ProjCode, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProjType, CivTableTemp::FILED_INT);
    addProperty(fileds.ProjGeom, CivTableTemp::FILED_GEOM_POINT);
    addProperty(fileds.ProjSn, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProjXcoord, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjYcoord, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjDesc, CivTableTemp::FILED_CHARACTER_VARYING);
    addProperty(fileds.ProjLabel, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProElev, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjBaseDemand, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjPattern, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProjDemandType, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProjDiffuserCoeff, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjInitQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjSourceQuality, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjDmaID, CivTableTemp::FILED_VARCHAR64);
    addProperty(fileds.ProjDemand, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjConsumption, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjLackWater, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjLackWaterPer, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjTotalWater, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjTotalHead, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjPressure, CivTableTemp::FILED_DOUBLE);
    addProperty(fileds.ProjQuality, CivTableTemp::FILED_DOUBLE);
}


/**
   ߱
*/
CivProjPipeTableTemp::CivProjPipeTableTemp() : CivTableTemp()
{
    setName(PROJPIPETABLE);
    TableField fileds;

     addProperty(fileds.ProjCode , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjType , CivTableTemp::FILED_BOOLEAN);// "޸";
     addProperty(fileds.ProjGeom , CivTableTemp::FILED_GEOM_LINE);// "Geom";
     addProperty(fileds.ProjSn , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjStartID , CivTableTemp::FILED_VARCHAR64);// "ʼڵ";
     addProperty(fileds.ProjEndID , CivTableTemp::FILED_VARCHAR64);// "ֹڵ";
     addProperty(fileds.ProjDesc , CivTableTemp::FILED_CHARACTER_VARYING);// "";
     addProperty(fileds.ProjLabel , CivTableTemp::FILED_VARCHAR64);// "ǩ";
     addProperty(fileds.ProjLength , CivTableTemp::FILED_DOUBLE);// "ܳ";
     addProperty(fileds.ProjDiameter , CivTableTemp::FILED_DOUBLE);// "ܾ";
     addProperty(fileds.ProjMaterial , CivTableTemp::FILED_VARCHAR64);// "ܲ";
     addProperty(fileds.ProjFractionCoeff , CivTableTemp::FILED_DOUBLE);// "Ħϵ";
     addProperty(fileds.ProjLoclLossCoeff , CivTableTemp::FILED_DOUBLE);// "ϵ";
     addProperty(fileds.ProjInitStatus , CivTableTemp::FILED_VARCHAR64);// "ʼ״̬";
     addProperty(fileds.ProjMainstreamCoeff , CivTableTemp::FILED_DOUBLE);// "ϵ";
     addProperty(fileds.ProjWallCoeff , CivTableTemp::FILED_DOUBLE);// "ܱϵ";
     addProperty(fileds.ProjLeakageCoeff1 , CivTableTemp::FILED_DOUBLE);// "©ˮϵ1";
     addProperty(fileds.ProLeakageCoeff2 , CivTableTemp::FILED_DOUBLE);// "©ˮϵ2";
     addProperty(fileds.ProjDmaID , CivTableTemp::FILED_VARCHAR64);// "DMAID";
     addProperty(fileds.ProjFlow , CivTableTemp::FILED_DOUBLE);// "";
     addProperty(fileds.ProjVelocity , CivTableTemp::FILED_DOUBLE);// "";
     addProperty(fileds.ProjUnitLoss , CivTableTemp::FILED_DOUBLE);// "λˮ";
     addProperty(fileds.ProjStatus , CivTableTemp::FILED_DOUBLE);// "״̬";
     addProperty(fileds.ProjQuality , CivTableTemp::FILED_DOUBLE);// "ˮ";
     addProperty(fileds.ProjWaterLeakage , CivTableTemp::FILED_DOUBLE);// "©ˮ";

}

/**
  
*/
CivProjTableTemp::CivProjTableTemp() : CivTableTemp()
{
    setName(PROJTABLE);
    TableField fileds;


     addProperty(fileds.ProjName , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjCode , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjType , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjCreator , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjAddTime , CivTableTemp::FILED_DATETIME);// "ʱ";
     addProperty(fileds.ProjUpdateTime , CivTableTemp::FILED_DATETIME);// "ʱ";
     addProperty(fileds.ProjTime , CivTableTemp::FILED_DATETIME);// "ʱ";
     addProperty(fileds.ProjScore , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProDescribe , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjEvaluate , CivTableTemp::FILED_VARCHAR64);// "";
     addProperty(fileds.ProjDemand , CivTableTemp::FILED_DOUBLE);// "ˮ";
     addProperty(fileds.ProjWorkCode , CivTableTemp::FILED_VARCHAR64);// "ҵ";
     addProperty(fileds.ProjDetection , CivTableTemp::FILED_VARCHAR64);// "ע";
}

/**
    ѹ
*/
CivMonitorPressureTableTemp::CivMonitorPressureTableTemp() : CivTableTemp()
{
    setName(PRESSURETABLE);
    TableField fileds;

    addProperty(fileds.MonitorScard, CivTableTemp::FILED_VARCHAR64);// "SCADAID";
    addProperty(fileds.MonitorXCoord, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorYCoord, CivTableTemp::FILED_DOUBLE);// "	";
    addProperty(fileds.MonitorDesc, CivTableTemp::FILED_CHARACTER_VARYING);// "";
    addProperty(fileds.MonitorLabel, CivTableTemp::FILED_VARCHAR64);// "ǩ";
    addProperty(fileds.MonitorNode, CivTableTemp::FILED_VARCHAR64);// "ڵID	";
    addProperty(fileds.MonitorMonitor, CivTableTemp::FILED_DOUBLE);// "ֵ	";
    addProperty(fileds.MonitorCalc, CivTableTemp::FILED_DOUBLE);// "ֵ	";
    addProperty(fileds.MonitorError, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorMonitorAverage, CivTableTemp::FILED_DOUBLE);// "ƽֵ";
    addProperty(fileds.MonitorCalcAverage, CivTableTemp::FILED_DOUBLE);// "ƽֵ";
    addProperty(fileds.MonitorErrorAverage, CivTableTemp::FILED_DOUBLE);// "ƽ	";
    addProperty(fileds.MonitorAbsErrirAverage, CivTableTemp::FILED_DOUBLE);// "ƽ";
    addProperty(fileds.MonitorSquareError, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorErrorFlu, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorNashCoeff, CivTableTemp::FILED_DOUBLE);// "ʲϵ";
    addProperty(fileds.MonitorScore, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorReliability, CivTableTemp::FILED_VARCHAR64);// "ɿ";

}

/*
    
*/
CivMonitorFlowTableTemp::CivMonitorFlowTableTemp() : CivTableTemp()
{
    setName(FLOWTABLE);
    TableField fileds;

    addProperty(fileds.MonitorScard, CivTableTemp::FILED_VARCHAR64);// "SCADAID";
    addProperty(fileds.MonitorXCoord, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorYCoord, CivTableTemp::FILED_DOUBLE);// "	";
    addProperty(fileds.MonitorDesc, CivTableTemp::FILED_VARCHAR64);// "";
    addProperty(fileds.MonitorLabel, CivTableTemp::FILED_VARCHAR64);// "ǩ";
    addProperty(fileds.MonitorPipe, CivTableTemp::FILED_VARCHAR64);// "ڵID";
    addProperty(fileds.MonitorMonitor, CivTableTemp::FILED_DOUBLE);// "ֵ	";
    addProperty(fileds.MonitorCalc, CivTableTemp::FILED_DOUBLE);// "ֵ	";
    addProperty(fileds.MonitorError, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorMonitorAverage, CivTableTemp::FILED_DOUBLE);// "ƽֵ";
    addProperty(fileds.MonitorCalcAverage, CivTableTemp::FILED_DOUBLE);// "ƽֵ";
    addProperty(fileds.MonitorErrorAverage, CivTableTemp::FILED_DOUBLE);// "ƽ	";
    addProperty(fileds.MonitorAbsErrirAverage, CivTableTemp::FILED_DOUBLE);// "ƽ";
    addProperty(fileds.MonitorSquareError, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorErrorFlu, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorNashCoeff, CivTableTemp::FILED_DOUBLE);// "ʲϵ";
    addProperty(fileds.MonitorScore, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorReliability, CivTableTemp::FILED_VARCHAR64);// "ɿ";
}

/*
   ˮʼ
*/
CivMonitorQualityTableTemp::CivMonitorQualityTableTemp() : CivTableTemp()
{
    setName(QUALITYTABLE);
    TableField fileds;

    addProperty(fileds.MonitorScard, CivTableTemp::FILED_VARCHAR64);// "SCADAID";
    addProperty(fileds.MonitorXCoord, CivTableTemp::FILED_DOUBLE);// "";
    addProperty(fileds.MonitorYCoord, CivTableTemp::FILED_DOUBLE);// "	";
    addProperty(fileds.MonitorDesc, CivTableTemp::FILED_CHARACTER_VARYING);// "";
    addProperty(fileds.MonitorLabel, CivTableTemp::FILED_VARCHAR64);// "ǩ";
    addProperty(fileds.MonitorNode, CivTableTemp::FILED_VARCHAR64);// "ڵID	";
    addProperty(fileds.MonitorMonitor, CivTableTemp::FILED_DOUBLE); // "ֵ	";
    addProperty(fileds.MonitorCalc, CivTableTemp::FILED_DOUBLE); // "ֵ	";
    addProperty(fileds.MonitorError, CivTableTemp::FILED_DOUBLE); // "";
    addProperty(fileds.MonitorMonitorAverage, CivTableTemp::FILED_DOUBLE); // "ƽֵ";
    addProperty(fileds.MonitorCalcAverage, CivTableTemp::FILED_DOUBLE); // "ƽֵ";
    addProperty(fileds.MonitorErrorAverage, CivTableTemp::FILED_DOUBLE); // "ƽ	";
    addProperty(fileds.MonitorAbsErrirAverage, CivTableTemp::FILED_DOUBLE); // "ƽ";
    addProperty(fileds.MonitorSquareError, CivTableTemp::FILED_DOUBLE); // "";
    addProperty(fileds.MonitorErrorFlu, CivTableTemp::FILED_DOUBLE); // "";
    addProperty(fileds.MonitorNashCoeff, CivTableTemp::FILED_DOUBLE); // "ʲϵ";
    addProperty(fileds.MonitorScore, CivTableTemp::FILED_DOUBLE); // "";
    addProperty(fileds.MonitorReliability, CivTableTemp::FILED_VARCHAR64); // "ɿ";
}
